function deformedShape(XYZ0, d, CON, scale, figID)

figure(figID)
cla
hold on
for i = 1:length(CON(:,1))
    plot( [XYZ0(CON(i,1),1), XYZ0(CON(i,2),1)], [XYZ0(CON(i,1),2), XYZ0(CON(i,2),2)], 'color', 'blue');
end
XYZ = XYZ0 + d*scale;
for i = 1:length(CON(:,1))
    plot( [XYZ(CON(i,1),1), XYZ(CON(i,2),1)], [XYZ(CON(i,1),2), XYZ(CON(i,2),2)], '--', 'color', 'red');
end
axis equal
% axis tight
title(['Deformation of the truss, scaled by ', num2str(scale), ' times']);
xlabel('x-axis');
ylabel('y-axis');