function [XYZ, N] = linearAnalysis(XYZ, CON, EA, BOUN, LOAD, dim)

for i = 1:length(CON(:,1))      % ڑs
    C( i, CON(i,1) ) = 1;
    C( i, CON(i,2) ) = -1;
end
[nm, nn] = size(C);
nd = dim * nn;              %  Rx

P = zeros(nd, 1);
for i = 1:length(LOAD(:,1))
    P( (LOAD(i,2)-1)*nn + LOAD(i,1) ) = LOAD(i,3);
end

d = ones( nd, 1 );
for i = 1:length( BOUN(:,1) )
    for j = 1:dim
        if BOUN(i, j+1) == 1
            d( (j-1)*nn+ BOUN(i,1) ) = 0;
        end
    end
end
count = 0;
for i = 1:nd                 % ό`ł鎩Rx
    if d(i) == 1
        count = count + 1;
        DOF( count ) = i;
    end
end
ndof = length(DOF);                 % ό`ł鎩Rx̐

T = eye( nd );  
j = nd;
for i = ndof : -1 : 1               % ]s
    if j ~= DOF(i)
        T0 = T( j,: );
        T( j, : ) = T( DOF(i), : );
        T( DOF(i), : ) = T0;
    end
    j = j - 1;
end

XYZ0 = XYZ;
u = C * XYZ0(:, 1); 
v = C * XYZ0(:, 2);
l0 = sqrt ( u.^2 + v.^2  );
    
invL = inv( diag(l0) );
D = [ C'*diag(u)*invL;   C'*diag(v)*invL];    % ނ荇s
K = D * diag(EA) * invL * D';      % `s

Kt = T * K * T';
Pt = T * P;
dt = T * d;

K11 = Kt(1:(nd-ndof), 1:(nd-ndof));
K12 = Kt(1:(nd-ndof), nd-ndof+1:nd);
K21 = Kt(nd-ndof+1:nd, 1:(nd-ndof));
K22 = Kt(nd-ndof+1:nd, nd-ndof+1:nd);

dk = dt(1:nd-ndof);
Pk = Pt(nd-ndof+1:nd);
du = inv(K22) * ( Pk - K21*dk );    %
Pu = K11*dk +K12*du;

d = T' * [ dk; du];
P = T' * [Pu; Pk];
XYZ = XYZ0 + [d(1:nn), d(nn+1:end)];

u = C * XYZ(:, 1); 
v = C * XYZ(:, 2);
l = sqrt ( u.^2 + v.^2  );    

N = ((l-l0)/l0) * EA'; %